﻿using Syncfusion.Pdf;
using Syncfusion.XlsIO;
using Syncfusion.XlsIORenderer;
using System;
using System.IO;

namespace XlsIOExportPDFProblem
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("Hello World!");
            ProcessExcel();
        }

        private static void ProcessExcel()
        {

            string fileTemplate = AppDomain.CurrentDomain.BaseDirectory + "\\template\\template.xlsx";
            if (!File.Exists(fileTemplate))
            {
                return;
            }
            ExcelEngine excelEngine = new ExcelEngine();
            IWorkbook workbook = null;
            FileStream inputStream = null;
            PdfDocument pdfDocument = null;
            FileStream outputXlsx = null;
            FileStream outputPdf = null;

            try
            {
                inputStream = new FileStream(fileTemplate, FileMode.Open);
                workbook = excelEngine.Excel.Workbooks.Open(inputStream);

                IWorksheet sheet = workbook.Worksheets[0];

                SetData(sheet);

                sheet.DisableSheetCalculations();
                sheet.EnableSheetCalculations();

                IWorksheet worksheet = workbook.Worksheets["Imprimir"];

                XlsIORenderer renderer = new XlsIORenderer();

                pdfDocument = renderer.ConvertToPDF(worksheet);

                string filenameXlsx = AppDomain.CurrentDomain.BaseDirectory + "\\template\\data.xlsx";
                outputXlsx = new FileStream(filenameXlsx, FileMode.Create);
                workbook.SaveAs(outputXlsx);

                string filenamePdf = AppDomain.CurrentDomain.BaseDirectory + "\\template\\data.pdf";
                outputPdf = new FileStream(filenamePdf, FileMode.Create);
                pdfDocument.Save(outputPdf);
            }
            catch (Exception ex)
            {
                throw;
            }
            finally
            {
                inputStream.Close();
                workbook.Close();
                outputXlsx.Close();
                outputPdf.Close();
                excelEngine.Dispose();
            }
            
        }

        private static void SetData(IWorksheet sheet)
        {
            sheet.Range["C5"].Value = "28231";
            sheet.Range["C6"].Value = "Madrid";


            sheet.Range["C11"].Value = "2500";
            sheet.Range["C12"].Value = "5,75";
            sheet.Range["C13"].Value = "Monofásica";
            sheet.Range["C14"].Value = "Vivienda";
            sheet.Range["C16"].Value = "Tardes y noches";
            sheet.Range["C17"].Value = "Aire acondicionado";            

            sheet.Range["C33"].Value = "Alta";

            sheet.Range["C37"].Value = "0,2";
            sheet.Range["C39"].Value = "7";
        }
    }
}
